import request from './request';
import util from './util.js';
var endpoints = {
    upload: 'elab-marketing-system/behavior/brandMiniWeb/upload', //埋点接口
    login: 'elab-marketing-user/login/xcxLogin', //小程序登录接口
    brandXcxLogin: 'elab-marketing-user/applet/login', //集团小程序登录
    webXcxLogin: 'elab-marketing-user/htmlLogin/login', //H5平台小程序登录
    getIpAddr: 'elab-marketing-user/ipAddr/getIpAddr',
    getWebsdkLink: "elab-marketing-sms/qly/getWebsdkLink",            // 获取监控视频地址
};
var doubleClickList = [];
export default async (endpoint, options, isHideLoading = null, preventDoubleClick = false, method = 'POST') => {
    if (!endpoints.hasOwnProperty(endpoint)) {
        console.error(`no such endpoint: ${endpoint}`);
        return {
            message: "不存在该接口"
        };
    }
    const requestOptions = {
        path: endpoints[endpoint],
        data: options,
        method: method || "POST",
    };
    if(requestOptions.method == 'get'){
        requestOptions.path = requestOptions.path + util.converToUrl(options)
    }
    if (preventDoubleClick) {
        //说明该接口需要防止连击
        if (doubleClickList[requestOptions.path] && doubleClickList[requestOptions.path].isRunning) {
            console.log(`${requestOptions.path}触发连击，屏蔽该请求`)
            return
        } else {
            console.log(`${requestOptions.path}触发连击，通过`)
            doubleClickList[requestOptions.path] = {
                isRunning: true
            }
        }
    }
    console.log(`获取${requestOptions.path}请求的参数:`, requestOptions.data)
    const response = await window.axios.post(requestOptions.path, requestOptions.data);
    //说明该接口需要防止连击
    if (preventDoubleClick && doubleClickList[requestOptions.path] && doubleClickList[requestOptions.path].isRunning) {
        console.log(`${requestOptions.path}连击接口已返回，清空连击数组`)
        doubleClickList[requestOptions.path].isRunning = false
    }
    console.log('返回' + requestOptions.path + '请求的结果:', response)
    return response;
}
